#ifndef _PLA_CRYPTO_IMPL_H
#define _PLA_CRYPTO_IMPL_H

#include <linux/types.h>
#include <linux/netlink.h>

#include "pla_crypto.h"

#define CRYPTO_IMPL_TIMER      1
#define CRYPTO_IMPL_USERSPACE  2

struct pla_crypto_impl
{
	int (*crypto_impl_init) (void);
	void (*crypto_impl_uninit) (void);

	int (*crypto_netlink) (struct nlmsghdr *nlh);

	int (*call_crypto) (void (*callback) (void *call_state),
			    void *state, 
			    struct pla_crypto_task *task);
};

struct pla_crypto_impl *pla_crypto_get_impl(int impl);

#endif /* _PLA_CRYPTO_IMPL_H */

