#ifndef _PLA_HEADER_H
#define _PLA_HEADER_H

#include <linux/skbuff.h>
#include <linux/version.h>
#include <linux/ipv6.h>

#include "kernel_ver.h"
#include "configs.h"

struct pla_hdr 
{
	/* Header starts at 8n + 4 */
	uint32_t ttp_id;

	uint64_t seqnum;

	char certificate[PLA_CERT_LEN];
	char signature[PLA_SIG_LEN];

	char id_hash[PLA_HASH_DIGEST_LENGTH];
	uint32_t pad4;

	uint32_t creation_time;
} __attribute__ ((packed));

struct hbh_and_pla_hdr 
{
	struct ipv6_hopopt_hdr hop_hdr;      /* Packet hop-by-hop header */
	struct ipv6_opt_hdr pla_option_hdr;  /* Option header for PLA */

	struct pla_hdr pla;                  /* The header itself */

	uint32_t padding_to_8_multiple;
} __attribute__ ((packed));


#define HLEN (sizeof(struct hbh_and_pla_hdr))     /* How many extra bytes are needed in the packet. Must be a multiple of 8 */

int pla_add_pla_option(struct sk_buff *skb);
struct pla_hdr* pla_find_pla_header(struct sk_buff *skb);
int pla_add_header(struct sk_buff **skb);
int pla_add_header_forward(struct sk_buff **skb);

int pla_strip_pla_header(struct sk_buff **skb);

#endif // _PLA_HEADER_H
