#ifndef _PLA_NETLINK_H
#define _PLA_NETLINK_H

#include <linux/in.h>

#define NETLINK_PLA 30

#define NLMSG_PLA_ADD             0x10     /* Set crypto hardware IP address */
#define NLMSG_PLA_SET_INTERFACES  0x12     /* jlu XXX: TBR */
#define NLMSG_PLA_SET_SRC         0x13     /* Configure the source identity (key) */

struct pla_netlink_target
{
	struct in_addr addr;
};

#define PLA_FORWARD_POLICY_NONE     0      /* No policy configured */
#define PLA_FORWARD_POLICY_DROP     1      /* Drop packet */
#define PLA_FORWARD_POLICY_SIGN     2      /* Add PLA header */
#define PLA_FORWARD_POLICY_VERIFY   3      /* Verify and forward */
#define PLA_FORWARD_POLICY_STRIP    4      /* Remove PLA header */

#define PLA_FORWARD_POLICY_MAX      4

struct pla_netlink_set_interface
{
	__u16 if_in;
	__u16 if_out;
	__u16 policy;
};

struct pla_netlink_add_src
{
	__u16 publen;
	__u16 privlen;
	__u16 certlen;
	__u16 id_hashlen;

	char data[0];   /* Public key, private key, cert, id_hash in that order */
};


#ifdef __KERNEL__

enum pla_netlink_groups 
{
        PLAGRP_NONE,
#define PLAGRP_NONE                    PLAGRP_NONE
        PLAGRP_CONNTRACK_NEW,
#define PLAGRP_CONNTRACK_NEW           PLAGRP_CONNTRACK_NEW
        __PLAGRP_MAX,
};

#define PLAGRP_MAX     (__PLAGRP_MAX - 1)


void pla_netlink_uninit(void);
int pla_netlink_init(void);

#endif /* __KERNEL__ */

#endif /* _PLA_NETLINK_H */
